//+------------------------------------------------------------------+
//|                                                  CS_Stoch_EA.mq4 |
//|                                               Erick_Fenstermaker |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Erick_Fenstermaker"
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#include <stderror.mqh>
#include <stdlib.mqh>


//--- input parameters
extern double StopLoss=0;
extern double TakeProfit=10;
input double   LotSize=0.01;
//Sets how far apart the currency strengths need to be before a trade will be placed
extern double gap = 5;
extern int lookBack = 240;

//Stochastic Settings.
extern string st1;//Stochastic Settings
extern int Kperiod = 5;//KPeriod.
extern int Dperiod = 3;//DPeriod.
extern int Slowing = 3;//Slowing.
extern ENUM_MA_METHOD method = 0;//MA Method.
extern string rm1;//Risk Management Settings.

extern int Slippage=30;
extern int MagicSeed=1000;
input string  Password = "HolyGrail";//Please Enter Your Password.
double pips;
int magic=0;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
// Determine what a pip is.
   pips =Point; //.00001 or .0001. .001 .01.
   if(Digits==3||Digits==5)
   pips*=10;
//   #include<InitChecks.mqh>
   Comment("Expert Loaded Successfully");
   return(INIT_SUCCEEDED);
  }

//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
datetime candletime = 0;
void OnTick()
  {
   if(candletime == Time[0]) return;
   candletime=Time[0];
   CheckForSignal();
  }
void CheckForSignal(){

//Gathers the EUR Symbol close values from the past (Base Values)   
double lookBackEURGBP = iOpen("EURGBP",0,1);
double lookBackEURAUD = iOpen("EURAUD",0,1);
double lookBackEURNZD = iOpen("EURNZD",0,1);
double lookBackEURUSD = iOpen("EURUSD",0,1);
double lookBackEURCAD = iOpen("EURCAD",0,1);
double lookBackEURCHF = iOpen("EURCHF",0,1);
double lookBackEURJPY = iOpen("EURJPY",0,1);

//Gathers the GBP Symbol close values from the past (Base Values)   
double lookBackGBPAUD = iOpen("GBPAUD",0,1);
double lookBackGBPNZD = iOpen("GBPNZD",0,1);
double lookBackGBPUSD = iOpen("GBPUSD",0,1);
double lookBackGBPCAD = iOpen("GBPCAD",0,1);
double lookBackGBPCHF = iOpen("GBPCHF",0,1);
double lookBackGBPJPY = iOpen("GBPJPY",0,1);

//Gathers the AUD Symbol close values from the past (Base Values)   
double lookBackAUDNZD = iOpen("AUDNZD",0,1);
double lookBackAUDUSD = iOpen("AUDUSD",0,1);
double lookBackAUDCAD = iOpen("AUDCAD",0,1);
double lookBackAUDCHF = iOpen("AUDCHF",0,1);
double lookBackAUDJPY = iOpen("AUDJPY",0,1);

//Gathers the NZD Symbol close values from the past (Base Values)   
double lookBackNZDUSD = iOpen("NZDUSD",0,1);
double lookBackNZDCAD = iOpen("NZDCAD",0,1);
double lookBackNZDCHF = iOpen("NZDCHF",0,1);
double lookBackNZDJPY = iOpen("NZDJPY",0,1);

//Gathers the USD Symbol close values from the past (Base Values)   
double lookBackUSDCAD = iOpen("USDCAD",0,1);
double lookBackUSDCHF = iOpen("USDCHF",0,1);
double lookBackUSDJPY = iOpen("USDJPY",0,1);

//Gathers the CAD Symbol close values from the past (Base Values)   
double lookBackCADCHF = iOpen("CADCHF",0,1);
double lookBackCADJPY = iOpen("CADJPY",0,1);

//Gathers the CHF Symbol close values from the past (Base Values)   
double lookBackCHFJPY = iOpen("CHFJPY",0,1);


//Gathers the current EUR Symbol Ask Values
double EURGBP = iOpen("EURGBP", 0,lookBack);
double EURAUD = iOpen("EURAUD", 0,lookBack);
double EURNZD = iOpen("EURNZD", 0,lookBack);
double EURUSD = iOpen("EURUSD", 0,lookBack);
double EURCAD = iOpen("EURCAD", 0,lookBack);
double EURCHF = iOpen("EURCHF", 0,lookBack);
double EURJPY = iOpen("EURJPY", 0,lookBack);

//Gathers the current GBP Symbol Ask Values
double GBPAUD = iOpen("GBPAUD", 0,lookBack);
double GBPNZD = iOpen("GBPNZD", 0,lookBack);
double GBPUSD = iOpen("GBPUSD", 0,lookBack);
double GBPCAD = iOpen("GBPCAD", 0,lookBack);
double GBPCHF = iOpen("GBPCHF", 0,lookBack);
double GBPJPY = iOpen("GBPJPY", 0,lookBack);

//Gathers the current AUD Symbol Ask Values
double AUDNZD = iOpen("AUDNZD", 0,lookBack);
double AUDUSD = iOpen("AUDUSD", 0,lookBack);
double AUDCAD = iOpen("AUDCAD", 0,lookBack);
double AUDCHF = iOpen("AUDCHF", 0,lookBack);
double AUDJPY = iOpen("AUDJPY", 0,lookBack);

//Gathers the current NZD Symbol Ask Values
double NZDUSD = iOpen("NZDUSD", 0,lookBack);
double NZDCAD = iOpen("NZDCAD", 0,lookBack);
double NZDCHF = iOpen("NZDCHF", 0,lookBack);
double NZDJPY = iOpen("NZDJPY", 0,lookBack);

//Gathers the current USD Symbol Ask Values
double USDCAD = iOpen("USDCAD", 0,lookBack);
double USDCHF = iOpen("USDCHF", 0,lookBack);
double USDJPY = iOpen("USDJPY", 0,lookBack);

//Gathers the current CAD Symbol Ask Values
double CADCHF = iOpen("CADCHF", 0,lookBack);
double CADJPY = iOpen("CADJPY", 0,lookBack);

//Gathers the current CHF Symbol Ask Values
double CHFJPY = iOpen("CHFJPY", 0,lookBack);


//Calcualtes the percent change from the past open till the current ask of the EUR values
double perEURGBP = ((lookBackEURGBP - EURGBP) + 0.0000000001)/(EURGBP + 0.0000000001)*100;
double perEURAUD = ((lookBackEURAUD - EURAUD) + 0.0000000001)/(EURAUD + 0.0000000001)*100;
double perEURNZD = ((lookBackEURNZD - EURNZD) + 0.0000000001)/(EURNZD + 0.0000000001)*100;
double perEURUSD = ((lookBackEURUSD - EURUSD) + 0.0000000001)/(EURUSD + 0.0000000001)*100;
double perEURCAD = ((lookBackEURCAD - EURCAD) + 0.0000000001)/(EURCAD + 0.0000000001)*100;
double perEURCHF = ((lookBackEURCHF - EURCHF) + 0.0000000001)/(EURCHF + 0.0000000001)*100;
double perEURJPY = ((lookBackEURJPY - EURJPY) + 0.0000000001)/(EURJPY + 0.0000000001)*100;

//Calcualtes the percent change from the past open till the current ask of the GBP values
double perGBPAUD = ((lookBackGBPAUD - GBPAUD) + 0.0000000001)/(GBPAUD + 0.0000000001)*100;
double perGBPNZD = ((lookBackGBPNZD - GBPNZD) + 0.0000000001)/(GBPNZD + 0.0000000001)*100;
double perGBPUSD = ((lookBackGBPUSD - GBPUSD) + 0.0000000001)/(GBPUSD + 0.0000000001)*100;
double perGBPCAD = ((lookBackGBPCAD - GBPCAD) + 0.0000000001)/(GBPCAD + 0.0000000001)*100;
double perGBPCHF = ((lookBackGBPCHF - GBPCHF) + 0.0000000001)/(GBPCHF + 0.0000000001)*100;
double perGBPJPY = ((lookBackGBPJPY - GBPJPY) + 0.0000000001)/(GBPJPY + 0.0000000001)*100;

//Calcualtes the percent change from the past open till the current ask of the AUD values
double perAUDNZD = ((lookBackAUDNZD - AUDNZD) + 0.0000000001)/(AUDNZD + 0.0000000001)*100;
double perAUDUSD = ((lookBackAUDUSD - AUDUSD) + 0.0000000001)/(AUDUSD + 0.0000000001)*100;
double perAUDCAD = ((lookBackAUDCAD - AUDCAD) + 0.0000000001)/(AUDCAD + 0.0000000001)*100;
double perAUDCHF = ((lookBackAUDCHF - AUDCHF) + 0.0000000001)/(AUDCHF + 0.0000000001)*100;
double perAUDJPY = ((lookBackAUDJPY - AUDJPY) + 0.0000000001)/(AUDJPY + 0.0000000001)*100;

//Calcualtes the percent change from the past open till the current ask of the NZD values
double perNZDUSD = ((lookBackNZDUSD - NZDUSD) + 0.0000000001)/(NZDUSD + 0.0000000001)*100;
double perNZDCAD = ((lookBackNZDCAD - NZDCAD) + 0.0000000001)/(NZDCAD + 0.0000000001)*100;
double perNZDCHF = ((lookBackNZDCHF - NZDCHF) + 0.0000000001)/(NZDCHF + 0.0000000001)*100;
double perNZDJPY = ((lookBackNZDJPY - NZDJPY) + 0.0000000001)/(NZDJPY + 0.0000000001)*100;

//Calcualtes the percent change from the past open till the current ask of the USD values
double perUSDCAD = ((lookBackUSDCAD - USDCAD) + 0.0000000001)/(USDCAD + 0.0000000001)*100;
double perUSDCHF = ((lookBackUSDCHF - USDCHF) + 0.0000000001)/(USDCHF + 0.0000000001)*100;
double perUSDJPY = ((lookBackUSDJPY - USDJPY) + 0.0000000001)/(USDJPY + 0.0000000001)*100;

//Calcualtes the percent change from the past open till the current ask of the CAD values
double perCADCHF = ((lookBackCADCHF - CADCHF) + 0.0000000001)/(CADCHF + 0.0000000001)*100;
double perCADJPY = ((lookBackCADJPY - CADJPY) + 0.0000000001)/(CADJPY + 0.0000000001)*100;

//Calcualtes the percent change from the past open till the current ask of the CHF values
double perCHFJPY = ((lookBackCHFJPY - CHFJPY) + 0.0000000001)/(CHFJPY + 0.0000000001)*100;
     
     
//Calculates true strength of the individual currency's
double perEUR = (perEURGBP + perEURAUD + perEURNZD + perEURUSD + perEURCAD + perEURCHF + perEURJPY);
double perGBP = ((-perEURGBP) + perGBPAUD + perGBPNZD + perGBPUSD + perGBPCAD + perGBPCHF + perGBPJPY);     
double perAUD = (((-perEURAUD) + (-perGBPAUD)) + perAUDNZD + perAUDUSD + perAUDCAD + perAUDCHF + perAUDJPY);
double perNZD = (((-perEURNZD) + (-perGBPNZD) + (-perAUDNZD)) + perNZDUSD + perNZDCAD + perNZDCHF + perNZDJPY);
double perUSD = (((-perEURUSD) + (-perGBPUSD) + (-perAUDUSD) + (-perNZDUSD)) + perUSDCAD + perUSDCHF + perUSDJPY);
double perCAD = (((-perEURCAD) + (-perGBPCAD) + (-perAUDCAD) + (-perNZDCAD) + (-perUSDCAD)) + perCADCHF + perCADJPY);
double perCHF = (((-perEURCHF) + (-perGBPCHF) + (-perAUDCHF) + (-perNZDCHF) + (-perUSDCHF) + (-perCADCHF)) + perCHFJPY);
double perJPY = ((-perEURJPY) + (-perGBPJPY) + (-perAUDJPY) + (-perNZDJPY) + (-perUSDJPY) + (-perCADJPY) + (-perCHFJPY));

//Settings for the stochastics      
double currentK = iStochastic(NULL, PERIOD_CURRENT, Kperiod, Dperiod, Slowing, method, 0, MODE_MAIN,1);
double previousK = iStochastic(NULL, PERIOD_CURRENT, Kperiod, Dperiod, Slowing, method, 0, MODE_MAIN,2);
double currentD = iStochastic(NULL, PERIOD_CURRENT, Kperiod, Dperiod, Slowing, method, 0, MODE_SIGNAL,1);
double previousD = iStochastic(NULL, PERIOD_CURRENT, Kperiod, Dperiod, Slowing, method, 0, MODE_SIGNAL,2);

      
      
//+------------------------------------------------------------------+
//|                Purchase or sell the EUR Pairs                    |
//+------------------------------------------------------------------+

//Signals to purchase or sell the EURGBP
   double GbpEurDiff = perGBP - perEUR;  //Check to see if the difference is below zero
      if(GbpEurDiff < 0)
      {     
      GbpEurDiff = -GbpEurDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perGBP > perEUR && GbpEurDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        CheckForSignal();
        EnterTrade(OP_BUY);
        }
        
   double EurGbpDiff = perEUR - perGBP;  //Check to see if the difference is below zero
      if(EurGbpDiff < 0)
      {     
      EurGbpDiff = -EurGbpDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perEUR > perGBP && EurGbpDiff > gap && previousK > previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }
      
      
//Signals to purchase or sell the EURAUD
   double AudEurDiff = perAUD - perEUR;  //Check to see if the difference is below zero
      if(AudEurDiff < 0)
      {     
      AudEurDiff = -AudEurDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perAUD > perEUR && AudEurDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double EurAudDiff = perEUR - perAUD;  //Check to see if the difference is below zero
      if(EurAudDiff < 0)
      {     
      EurAudDiff = -EurAudDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perEUR > perAUD && EurAudDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }
        
            
//Signals to purchase or sell the EURNZD
   double NzdEurDiff = perNZD - perEUR;  //Check to see if the difference is below zero
      if(NzdEurDiff < 0)
      {     
      NzdEurDiff = -NzdEurDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perNZD > perEUR && NzdEurDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double EurNzdDiff = perEUR - perNZD;  //Check to see if the difference is below zero
      if(EurNzdDiff < 0)
      {     
      EurNzdDiff = -EurNzdDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perEUR > perNZD && EurNzdDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }
        
        
//Signals to purchase or sell the EURUSD
   double UsdEurDiff = perUSD - perEUR;  //Check to see if the difference is below zero
      if(UsdEurDiff < 0)
      {     
      UsdEurDiff = -UsdEurDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perUSD > perEUR && UsdEurDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double EurUsdDiff = perEUR - perUSD;  //Check to see if the difference is below zero
      if(EurUsdDiff < 0)
      {     
      EurUsdDiff = -EurUsdDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perEUR > perUSD && EurUsdDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }
        
        
//Signals to purchase or sell the EURCAD
   double CadEurDiff = perCAD - perEUR;  //Check to see if the difference is below zero
      if(CadEurDiff < 0)
      {     
      CadEurDiff = -CadEurDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perCAD > perEUR && CadEurDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double EurCadDiff = perEUR - perCAD;  //Check to see if the difference is below zero
      if(EurCadDiff < 0)
      {     
      EurCadDiff = -EurCadDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perEUR > perCAD && EurCadDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }
        
        
//Signals to purchase or sell the EURCHF
   double ChfEurDiff = perCHF - perEUR;  //Check to see if the difference is below zero
      if(ChfEurDiff < 0)
      {     
      ChfEurDiff = -ChfEurDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perCHF > perEUR && ChfEurDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double EurChfDiff = perEUR - perCHF;  //Check to see if the difference is below zero
      if(EurChfDiff < 0)
      {     
      EurChfDiff = -EurChfDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perEUR > perCHF && EurChfDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }


//Signals to purchase or sell the EURJPY
   double JpyEurDiff = perJPY - perEUR;  //Check to see if the difference is below zero
      if(JpyEurDiff < 0)
      {     
      JpyEurDiff = -JpyEurDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perJPY > perEUR && JpyEurDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double EurJpyDiff = perEUR - perJPY;  //Check to see if the difference is below zero
      if(EurJpyDiff < 0)
      {     
      EurJpyDiff = -EurJpyDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perEUR > perJPY && EurJpyDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }


//+------------------------------------------------------------------+
//|                 Purchase or sell the GBP Pairs                   |
//+------------------------------------------------------------------+
      
//Signals to purchase or sell the GBPAUD
   double AudGbpDiff = perAUD - perGBP;  //Check to see if the difference is below zero
      if(AudGbpDiff < 0)
      {     
      AudGbpDiff = -AudGbpDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perAUD > perGBP && AudGbpDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double GbpAudDiff = perGBP - perAUD;  //Check to see if the difference is below zero
      if(GbpAudDiff < 0)
      {     
      GbpAudDiff = -GbpAudDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perGBP > perAUD && GbpAudDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }
        
            
//Signals to purchase or sell the GBPNZD
   double NzdGbpDiff = perNZD - perGBP;  //Check to see if the difference is below zero
      if(NzdGbpDiff < 0)
      {     
      NzdGbpDiff = -NzdGbpDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perNZD > perGBP && NzdGbpDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double GbpNzdDiff = perGBP - perNZD;  //Check to see if the difference is below zero
      if(GbpNzdDiff < 0)
      {     
      GbpNzdDiff = -GbpNzdDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perGBP > perNZD && GbpNzdDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }
        
        
//Signals to purchase or sell the GBPUSD
   double UsdGbpDiff = perUSD - perGBP;  //Check to see if the difference is below zero
      if(UsdGbpDiff < 0)
      {     
      UsdGbpDiff = -UsdGbpDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perUSD > perGBP && UsdGbpDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double GbpUsdDiff = perGBP - perUSD;  //Check to see if the difference is below zero
      if(GbpUsdDiff < 0)
      {     
      GbpUsdDiff = -GbpUsdDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perGBP > perUSD && GbpUsdDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }
        
        
//Signals to purchase or sell the GBPCAD
   double CadGbpDiff = perCAD - perGBP;  //Check to see if the difference is below zero
      if(CadGbpDiff < 0)
      {     
      CadGbpDiff = -CadGbpDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perCAD > perGBP && CadGbpDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double GbpCadDiff = perGBP - perCAD;  //Check to see if the difference is below zero
      if(GbpCadDiff < 0)
      {     
      GbpCadDiff = -GbpCadDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perGBP > perCAD && GbpCadDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }
        
        
//Signals to purchase or sell the GBPCHF
   double ChfGbpDiff = perCHF - perGBP;  //Check to see if the difference is below zero
      if(ChfGbpDiff < 0)
      {     
      ChfGbpDiff = -ChfGbpDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perCHF > perGBP && ChfGbpDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double GbpChfDiff = perGBP - perCHF;  //Check to see if the difference is below zero
      if(GbpChfDiff < 0)
      {     
      GbpChfDiff = -GbpChfDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perGBP > perCHF && GbpChfDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }


//Signals to purchase or sell the GBPJPY
   double JpyGbpDiff = perJPY - perGBP;  //Check to see if the difference is below zero
      if(JpyGbpDiff < 0)
      {     
      JpyGbpDiff = -JpyGbpDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perJPY > perGBP && JpyGbpDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double GbpJpyDiff = perGBP - perJPY;  //Check to see if the difference is below zero
      if(GbpJpyDiff < 0)
      {     
      GbpJpyDiff = -GbpJpyDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perGBP > perJPY && GbpJpyDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }


//+------------------------------------------------------------------+
//|                 Purchase or sell the AUD Pairs                   |
//+------------------------------------------------------------------+
            
//Signals to purchase or sell the AUDNZD
   double NzdAudDiff = perNZD - perAUD;  //Check to see if the difference is below zero
      if(NzdAudDiff < 0)
      {     
      NzdAudDiff = -NzdAudDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perNZD > perAUD && NzdAudDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double AudNzdDiff = perAUD - perNZD;  //Check to see if the difference is below zero
      if(AudNzdDiff < 0)
      {     
      AudNzdDiff = -AudNzdDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perAUD > perNZD && AudNzdDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }
        
        
//Signals to purchase or sell the AUDUSD
   double UsdAudDiff = perUSD - perAUD;  //Check to see if the difference is below zero
      if(UsdAudDiff < 0)
      {     
      UsdAudDiff = -UsdAudDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perUSD > perAUD && UsdAudDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double AudUsdDiff = perAUD - perUSD;  //Check to see if the difference is below zero
      if(AudUsdDiff < 0)
      {     
      AudUsdDiff = -AudUsdDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perAUD > perUSD && AudUsdDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }
        
        
//Signals to purchase or sell the AUDCAD
   double CadAudDiff = perCAD - perAUD;  //Check to see if the difference is below zero
      if(CadAudDiff < 0)
      {     
      CadAudDiff = -CadAudDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perCAD > perAUD && CadAudDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double AudCadDiff = perAUD - perCAD;  //Check to see if the difference is below zero
      if(AudCadDiff < 0)
      {     
      AudCadDiff = -AudCadDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perAUD > perCAD && AudCadDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }
        
        
//Signals to purchase or sell the AUDCHF
   double ChfAudDiff = perCHF - perAUD;  //Check to see if the difference is below zero
      if(ChfAudDiff < 0)
      {     
      ChfAudDiff = -ChfAudDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perCHF > perAUD && ChfAudDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double AudChfDiff = perAUD - perCHF;  //Check to see if the difference is below zero
      if(AudChfDiff < 0)
      {     
      AudChfDiff = -AudChfDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perAUD > perCHF && AudChfDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }


//Signals to purchase or sell the AUDJPY
   double JpyAudDiff = perJPY - perAUD;  //Check to see if the difference is below zero
      if(JpyAudDiff < 0)
      {     
      JpyAudDiff = -JpyAudDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perJPY > perAUD && JpyAudDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double AudJpyDiff = perAUD - perJPY;  //Check to see if the difference is below zero
      if(AudJpyDiff < 0)
      {     
      AudJpyDiff = -AudJpyDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perAUD > perJPY && AudJpyDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }
        
        
//+------------------------------------------------------------------+
//|                 Purchase or sell the NZD Pairs                   |
//+------------------------------------------------------------------+    
        
//Signals to purchase or sell the NZDUSD
   double UsdNzdDiff = perUSD - perNZD;  //Check to see if the difference is below zero
      if(UsdNzdDiff < 0)
      {     
      UsdNzdDiff = -UsdNzdDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perUSD > perNZD && UsdNzdDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double NzdUsdDiff = perNZD - perUSD;  //Check to see if the difference is below zero
      if(NzdUsdDiff < 0)
      {     
      NzdUsdDiff = -NzdUsdDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perNZD > perUSD && NzdUsdDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }
        
        
//Signals to purchase or sell the NZDCAD
   double CadNzdDiff = perCAD - perNZD;  //Check to see if the difference is below zero
      if(CadNzdDiff < 0)
      {     
      CadNzdDiff = -CadNzdDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(Symbol() == "NZDUCAD" && perCAD > perNZD && CadNzdDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double NzdCadDiff = perNZD - perCAD;  //Check to see if the difference is below zero
      if(NzdCadDiff < 0)
      {     
      NzdCadDiff = -NzdCadDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perNZD > perCAD && NzdCadDiff > gap && previousK > previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }
        
        
//Signals to purchase or sell the NZDCHF
   double ChfNzdDiff = perCHF - perNZD;  //Check to see if the difference is below zero
      if(ChfNzdDiff < 0)
      {     
      ChfNzdDiff = -ChfNzdDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perCHF > perNZD && ChfNzdDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double NzdChfDiff = perNZD - perCHF;  //Check to see if the difference is below zero
      if(NzdChfDiff < 0)
      {     
      NzdChfDiff = -NzdChfDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perNZD > perCHF && NzdChfDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }


//Signals to purchase or sell the NZDJPY
   double JpyNzdDiff = perJPY - perNZD;  //Check to see if the difference is below zero
      if(JpyNzdDiff < 0)
      {     
      JpyNzdDiff = -JpyNzdDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perJPY > perNZD && JpyNzdDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double NzdJpyDiff = perNZD - perJPY;  //Check to see if the difference is below zero
      if(NzdJpyDiff < 0)
      {     
      NzdJpyDiff = -NzdJpyDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perNZD > perJPY && NzdJpyDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }
        
       
//+------------------------------------------------------------------+
//|                  Purchase or sell the USD Pairs                  |
//+------------------------------------------------------------------+           
        
//Signals to purchase or sell the USDCAD
   double CadUsdDiff = perCAD - perUSD;  //Check to see if the difference is below zero
      if(CadUsdDiff < 0)
      {     
      CadUsdDiff = -CadUsdDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perCAD > perUSD && CadUsdDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double UsdCadDiff = perUSD - perCAD;  //Check to see if the difference is below zero
      if(UsdCadDiff < 0)
      {     
      UsdCadDiff = -UsdCadDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perUSD > perCAD && UsdCadDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }
        
        
//Signals to purchase or sell the USDCHF
   double ChfUsdDiff = perCHF - perUSD;  //Check to see if the difference is below zero
      if(ChfUsdDiff < 0)
      {     
      ChfUsdDiff = -ChfUsdDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perCHF > perUSD && ChfUsdDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double UsdChfDiff = perUSD - perCHF;  //Check to see if the difference is below zero
      if(UsdChfDiff < 0)
      {     
      UsdChfDiff = -UsdChfDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perUSD > perCHF && UsdChfDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }


//Signals to purchase or sell the USDJPY
   double JpyUsdDiff = perJPY - perUSD;  //Check to see if the difference is below zero
      if(JpyUsdDiff < 0)
      {     
      JpyUsdDiff = -JpyUsdDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perJPY > perUSD && JpyUsdDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double UsdJpyDiff = perUSD - perJPY;  //Check to see if the difference is below zero
      if(UsdJpyDiff < 0)
      {     
      UsdJpyDiff = -UsdJpyDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perUSD > perJPY && UsdJpyDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        } 
        
        
//+------------------------------------------------------------------+
//|                  Purchase or sell the CAD Pairs                  |
//+------------------------------------------------------------------+           
             
//Signals to purchase or sell the CADCHF
   double ChfCadDiff = perCHF - perCAD;  //Check to see if the difference is below zero
      if(ChfCadDiff < 0)
      {     
      ChfCadDiff = -ChfCadDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perCHF > perCAD && ChfCadDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double CadChfDiff = perCAD - perCHF;  //Check to see if the difference is below zero
      if(CadChfDiff < 0)
      {     
      CadChfDiff = -CadChfDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perCAD > perCHF && CadChfDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        }


//Signals to purchase or sell the CADJPY
   double JpyCadDiff = perJPY - perCAD;  //Check to see if the difference is below zero
      if(JpyCadDiff < 0)
      {     
      JpyCadDiff = -JpyCadDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perJPY > perCAD && JpyCadDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double CadJpyDiff = perCAD - perJPY;  //Check to see if the difference is below zero
      if(CadJpyDiff < 0)
      {     
      CadJpyDiff = -CadJpyDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perCAD > perJPY && CadJpyDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        } 
       
//+------------------------------------------------------------------+
//|                 Purchase or sell the CHF Pairs                   |
//+------------------------------------------------------------------+           
             
//Signals to purchase or sell the CHFJPY
   double JpyChfDiff = perJPY - perCHF;  //Check to see if the difference is below zero
      if(JpyChfDiff < 0)
      {     
      JpyChfDiff = -JpyChfDiff; //if its below zero invert the negative to positive 
      }
      //Enters a buy trade if the conditions are met
      if(perJPY > perCHF && JpyChfDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        {
        EnterTrade(OP_BUY);
        }
        
   double ChfJpyDiff = perCHF - perJPY;  //Check to see if the difference is below zero
      if(ChfJpyDiff < 0)
      {     
      ChfJpyDiff = -ChfJpyDiff; //if its below zero invert the negative to positive 
      }
      //Enters a sell trade if the conditions are met
      if(perCHF > perJPY && ChfJpyDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        {
        EnterTrade(OP_SELL);
        } 
        
   }
   
//+------------------------------------------------------------------+
//|     TRADE PLACING FUNCTION                                       |
//+------------------------------------------------------------------+
void EnterTrade(int type){

   int err=0;
   double price=Bid, sl=0, tp=0;
   if(type == OP_BUY)
      price =Ask;
   //----
   int ticket = OrderSend(Symbol(),type,LotSize,price,Slippage,0,0,"CS_Stoch_EA Trade",magic,0,Magenta); 
   if(ticket > 0){
      if(OrderSelect(ticket,SELECT_BY_TICKET)){
         sl = OrderOpenPrice()+(StopLoss*Point);
         if(StopLoss==0)sl=0;
         tp = OrderOpenPrice()-(TakeProfit*Point);
         if(OrderType()==OP_BUY){
            sl = OrderOpenPrice()-(StopLoss*Point);
            if(StopLoss==0)sl=0;
            tp = OrderOpenPrice()+(TakeProfit*Point);
         }
         if(!OrderModify(ticket,price,sl,tp,0,Magenta)) {
            err = GetLastError();
            Print("Encountered an error during modification!"+(string)err+" "+ErrorDescription(err)  );
         }
      }
      else{//in case it fails to select the order for some reason 
         Print("Failed to Select Order ",ticket);
         err = GetLastError();
         Print("Encountered an error while seleting order "+(string)ticket+" error number "+(string)err+" "+ErrorDescription(err)  );
      }
   }
   else{//in case it fails to place the order and send us back a ticket number.
      err = GetLastError();
      Print("Encountered an error during order placement!"+(string)err+" "+ErrorDescription(err)  );
      if(err==ERR_TRADE_NOT_ALLOWED)MessageBox("You can not place a trade because \"Allow Live Trading\" is not checked in your options. Please check the \"Allow Live Trading\" Box!","Check Your Settings!");
   }
}
int MagicNumberGenerator()
  {
   string mySymbol=StringSubstr(_Symbol,0,6);
   int pairNumber=0;
   int GeneratedNumber=0;
   if(mySymbol=="AUDCAD") pairNumber=1;
   else if(mySymbol == "AUDCHF")    pairNumber=2;
   else if(mySymbol == "AUDJPY")    pairNumber=3;
   else if(mySymbol == "AUDNZD")    pairNumber=4;
   else if(mySymbol == "AUDUSD")    pairNumber=5;
   else if(mySymbol == "CADCHF")    pairNumber=6;
   else if(mySymbol == "CADJPY")    pairNumber=7;
   else if(mySymbol == "CHFJPY")    pairNumber=8;
   else if(mySymbol == "EURAUD")    pairNumber=9;
   else if(mySymbol == "EURCAD")    pairNumber=10;
   else if(mySymbol == "EURCHF")    pairNumber=11;
   else if(mySymbol == "EURGBP")    pairNumber=12;
   else if(mySymbol == "EURJPY")    pairNumber=13;
   else if(mySymbol == "EURNZD")    pairNumber=14;
   else if(mySymbol == "EURUSD")    pairNumber=15;
   else if(mySymbol == "GBPAUD")    pairNumber=16;
   else if(mySymbol == "GBPCAD")    pairNumber=17;
   else if(mySymbol == "GBPCHF")    pairNumber=18;
   else if(mySymbol == "GBPJPY")    pairNumber=19;
   else if(mySymbol == "GBPNZD")    pairNumber=20;
   else if(mySymbol == "GBPUSD")    pairNumber=21;
   else if(mySymbol == "NZDCAD")    pairNumber=22;
   else if(mySymbol == "NZDJPY")    pairNumber=23;
   else if(mySymbol == "NZDCHF")    pairNumber=24;
   else if(mySymbol == "NZDUSD")    pairNumber=25;
   else if(mySymbol == "USDCAD")    pairNumber=26;
   else if(mySymbol == "USDCHF")    pairNumber=27;
   else if(mySymbol == "USDJPY")    pairNumber=28;
   else if(mySymbol == "XAGUSD")    pairNumber=29;
   else if(mySymbol == "XAUUSD")    pairNumber=30;
   else if(mySymbol == "SPX500")    pairNumber=31;
   else if(mySymbol == "AUS200")    pairNumber=32;
   //do the 5 character cfd's
   else mySymbol=StringSubstr(mySymbol,0,5);
   if(mySymbol      == "GER30")     pairNumber=33;
   else if(mySymbol == "FRA40")     pairNumber=34;
   //do the 4 characther cfd's
   else mySymbol=StringSubstr(mySymbol,0,4);
   if(mySymbol == "US30")      pairNumber=35;
   
   GeneratedNumber=MagicSeed+(pairNumber*1000)+_Period;
   return(GeneratedNumber);
  }